# coding: utf-8

"""
    Fideo API

    Fideo Intelligence offers an identity intelligence product that protects the public good. - [Fideo Privacy Policy](https://www.fideo.ai/privacy-policy/)

    The version of the OpenAPI document: 1.0.0
    Contact: support@fideo.ai
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from fideo_api.models.demographics import Demographics
from fideo_api.models.email import Email
from fideo_api.models.employment import Employment
from fideo_api.models.ip_address import IpAddress
from fideo_api.models.location import Location
from fideo_api.models.name import Name
from fideo_api.models.phone import Phone
from fideo_api.models.social_profile_urls import SocialProfileUrls
from typing import Optional, Set
from typing_extensions import Self

class SignalsResponseV0(BaseModel):
    """
    SignalsResponseV0
    """ # noqa: E501
    name: Optional[Name] = None
    demographics: Optional[Demographics] = None
    locations: Optional[List[Location]] = None
    emails: Optional[List[Email]] = None
    phones: Optional[List[Phone]] = None
    person_ids: Optional[List[StrictStr]] = Field(default=None, alias="personIds")
    ip_addresses: Optional[List[IpAddress]] = Field(default=None, alias="ipAddresses")
    message: Optional[StrictStr] = None
    social_profiles: Optional[SocialProfileUrls] = Field(default=None, alias="socialProfiles")
    employment: Optional[Employment] = None
    __properties: ClassVar[List[str]] = ["name", "demographics", "locations", "emails", "phones", "personIds", "ipAddresses", "message", "socialProfiles", "employment"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SignalsResponseV0 from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of name
        if self.name:
            _dict['name'] = self.name.to_dict()
        # override the default output from pydantic by calling `to_dict()` of demographics
        if self.demographics:
            _dict['demographics'] = self.demographics.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in locations (list)
        _items = []
        if self.locations:
            for _item in self.locations:
                if _item:
                    _items.append(_item.to_dict())
            _dict['locations'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in emails (list)
        _items = []
        if self.emails:
            for _item in self.emails:
                if _item:
                    _items.append(_item.to_dict())
            _dict['emails'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in phones (list)
        _items = []
        if self.phones:
            for _item in self.phones:
                if _item:
                    _items.append(_item.to_dict())
            _dict['phones'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in ip_addresses (list)
        _items = []
        if self.ip_addresses:
            for _item in self.ip_addresses:
                if _item:
                    _items.append(_item.to_dict())
            _dict['ipAddresses'] = _items
        # override the default output from pydantic by calling `to_dict()` of social_profiles
        if self.social_profiles:
            _dict['socialProfiles'] = self.social_profiles.to_dict()
        # override the default output from pydantic by calling `to_dict()` of employment
        if self.employment:
            _dict['employment'] = self.employment.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SignalsResponseV0 from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "name": Name.from_dict(obj["name"]) if obj.get("name") is not None else None,
            "demographics": Demographics.from_dict(obj["demographics"]) if obj.get("demographics") is not None else None,
            "locations": [Location.from_dict(_item) for _item in obj["locations"]] if obj.get("locations") is not None else None,
            "emails": [Email.from_dict(_item) for _item in obj["emails"]] if obj.get("emails") is not None else None,
            "phones": [Phone.from_dict(_item) for _item in obj["phones"]] if obj.get("phones") is not None else None,
            "personIds": obj.get("personIds"),
            "ipAddresses": [IpAddress.from_dict(_item) for _item in obj["ipAddresses"]] if obj.get("ipAddresses") is not None else None,
            "message": obj.get("message"),
            "socialProfiles": SocialProfileUrls.from_dict(obj["socialProfiles"]) if obj.get("socialProfiles") is not None else None,
            "employment": Employment.from_dict(obj["employment"]) if obj.get("employment") is not None else None
        })
        return _obj


