# coding: utf-8

"""
    Fideo API

    Fideo Intelligence offers an identity intelligence product that protects the public good. - [Fideo Privacy Policy](https://www.fideo.ai/privacy-policy/)

    The version of the OpenAPI document: 1.0.0
    Contact: support@fideo.ai
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from fideo_api.models.signals_response_v0 import SignalsResponseV0
from fideo_api.models.signals_response_v20240424 import SignalsResponseV20240424
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

VERIFYSIGNALSPOST200RESPONSE_ONE_OF_SCHEMAS = ["SignalsResponseV0", "SignalsResponseV20240424"]

class VerifySignalsPost200Response(BaseModel):
    """
    VerifySignalsPost200Response
    """
    # data type: SignalsResponseV0
    oneof_schema_1_validator: Optional[SignalsResponseV0] = None
    # data type: SignalsResponseV20240424
    oneof_schema_2_validator: Optional[SignalsResponseV20240424] = None
    actual_instance: Optional[Union[SignalsResponseV0, SignalsResponseV20240424]] = None
    one_of_schemas: Set[str] = { "SignalsResponseV0", "SignalsResponseV20240424" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = VerifySignalsPost200Response.model_construct()
        error_messages = []
        match = 0
        # validate data type: SignalsResponseV0
        if not isinstance(v, SignalsResponseV0):
            error_messages.append(f"Error! Input type `{type(v)}` is not `SignalsResponseV0`")
        else:
            match += 1
        # validate data type: SignalsResponseV20240424
        if not isinstance(v, SignalsResponseV20240424):
            error_messages.append(f"Error! Input type `{type(v)}` is not `SignalsResponseV20240424`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in VerifySignalsPost200Response with oneOf schemas: SignalsResponseV0, SignalsResponseV20240424. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in VerifySignalsPost200Response with oneOf schemas: SignalsResponseV0, SignalsResponseV20240424. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into SignalsResponseV0
        try:
            instance.actual_instance = SignalsResponseV0.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into SignalsResponseV20240424
        try:
            instance.actual_instance = SignalsResponseV20240424.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into VerifySignalsPost200Response with oneOf schemas: SignalsResponseV0, SignalsResponseV20240424. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into VerifySignalsPost200Response with oneOf schemas: SignalsResponseV0, SignalsResponseV20240424. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], SignalsResponseV0, SignalsResponseV20240424]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


